package com.tzld.piaoquan.ad.engine.service.score.impl;

import com.tzld.piaoquan.ad.engine.commons.base.AdRankItem;
import com.tzld.piaoquan.ad.engine.commons.base.UserAdFeature;
import com.tzld.piaoquan.ad.engine.commons.score.ScoreParam;
import com.tzld.piaoquan.ad.engine.commons.score.ScorerUtils;
import com.tzld.piaoquan.ad.engine.commons.util.CommonCollectionUtils;
import com.tzld.piaoquan.ad.engine.service.score.FeatureRemoteService;
import com.tzld.piaoquan.ad.engine.service.score.RankService;
import com.tzld.piaoquan.ad.engine.service.score.convert.RequestConvert;
import com.tzld.piaoquan.ad.engine.service.score.param.RankRecommendRequestParam;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.*;

@Service
public class RankServiceImpl implements RankService {

    private final static Logger log = LoggerFactory.getLogger(RankServiceImpl.class);
    @Autowired
    ApplicationContext applicationContext;

    @Autowired
    FeatureRemoteService featureRemoteService;

    public Long adItemRank( RankRecommendRequestParam request){

        ScoreParam param= RequestConvert.requestConvert(request);
        UserAdFeature userAdFeature=featureRemoteService.getUserAdFeature(request.getMid());
        if(userAdFeature==null){
            userAdFeature=new UserAdFeature();
        }
        List<AdRankItem> rankItems=featureRemoteService.
                getAllAdFeatureList(
                        CommonCollectionUtils.toList(request.getAdIdList(),id->id.toString())
                );
        List<AdRankItem> rankResult = ScorerUtils
                .getScorerPipeline(
                        ScorerUtils.BASE_CONF)
//                .scoring(convert(param), userFeature, rankItems);
                .scoring(param, userAdFeature, rankItems);
//        Collections.sort(rankResult, Comparator.comparingDouble(ad -> -ad.getScore()));
        if (!CollectionUtils.isEmpty(rankResult)) {
           return rankResult.get(0).getAdId();
        }else {
            return null;
        }
    }
}
